Index: /exampleparties/simpleboa/src/main/java/geniusweb/exampleparties/simpleboa/SimpleBoa.java
===================================================================
--- /exampleparties/simpleboa/src/main/java/geniusweb/exampleparties/simpleboa/SimpleBoa.java	(revision 20)
+++ /exampleparties/simpleboa/src/main/java/geniusweb/exampleparties/simpleboa/SimpleBoa.java	(revision 20)
@@ -0,0 +1,74 @@
+package geniusweb.exampleparties.simpleboa;
+
+import geniusweb.boa.BoaState;
+import geniusweb.boa.DefaultBoa;
+import geniusweb.boa.InstantiationFailedException;
+import geniusweb.boa.acceptancestrategy.AcceptanceStrategy;
+import geniusweb.boa.acceptancestrategy.TimeDependentAcceptanceStrategy;
+import geniusweb.boa.biddingstrategy.BiddingStrategy;
+import geniusweb.boa.biddingstrategy.TimeDependentBiddingStrategy;
+import geniusweb.opponentmodel.FrequencyOpponentModel;
+import geniusweb.opponentmodel.OpponentModel;
+import geniusweb.party.Party;
+import geniusweb.party.inform.Settings;
+import tudelft.utilities.logging.Reporter;
+
+/**
+ * This example illustrates how to make a custom party by extending Boa and
+ * plugging in some components. This is an easy way to make a {@link Party} that
+ * is not requiring configuration/parameters. This also demonstrates how to hard
+ * set parameters of strategies so that the party runs as expected without
+ * requiring any parameters to be set.
+ */
+public class SimpleBoa extends DefaultBoa {
+	public SimpleBoa() {
+		super();
+	}
+
+	public SimpleBoa(Reporter reporter) {
+		super(reporter); // for debugging
+	}
+
+	@Override
+	protected Class<? extends OpponentModel> getOpponentModel(Settings settings)
+			throws InstantiationFailedException {
+		return FrequencyOpponentModel.class;
+	}
+
+	@Override
+	protected BiddingStrategy getBiddingStrategy(Settings settings)
+			throws InstantiationFailedException {
+		return new TimeDependentBiddingStrategy() {
+			@Override
+			protected Double getE(BoaState state) {
+				return 0.7;
+			}
+
+			@Override
+			protected Double getK(BoaState state) {
+				return 0.2;
+			}
+		};
+	}
+
+	@Override
+	protected AcceptanceStrategy getAccceptanceStrategy(Settings settings)
+			throws InstantiationFailedException {
+		return new TimeDependentAcceptanceStrategy() {
+			@Override
+			protected Double getE(BoaState state) {
+				return 0.7;
+			}
+
+			@Override
+			protected Double getK(BoaState state) {
+				return 0.2;
+			}
+		};
+	}
+
+	@Override
+	public String getDescription() {
+		return "Demo of hard coding a party with Boa Components";
+	}
+}
Index: /exampleparties/simpleboa/src/test/java/geniusweb/exampleparties/simpleboa/SimpleBoaTest.java
===================================================================
--- /exampleparties/simpleboa/src/test/java/geniusweb/exampleparties/simpleboa/SimpleBoaTest.java	(revision 20)
+++ /exampleparties/simpleboa/src/test/java/geniusweb/exampleparties/simpleboa/SimpleBoaTest.java	(revision 20)
@@ -0,0 +1,229 @@
+package geniusweb.exampleparties.simpleboa;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertFalse;
+import static org.junit.Assert.assertNotNull;
+import static org.junit.Assert.assertTrue;
+import static org.mockito.Matchers.any;
+import static org.mockito.Matchers.eq;
+import static org.mockito.Mockito.mock;
+import static org.mockito.Mockito.verify;
+import static org.mockito.Mockito.when;
+
+import java.io.IOException;
+import java.math.BigDecimal;
+import java.net.URI;
+import java.net.URISyntaxException;
+import java.nio.charset.StandardCharsets;
+import java.nio.file.Files;
+import java.nio.file.Paths;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.logging.Level;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.Accept;
+import geniusweb.actions.Action;
+import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.Offer;
+import geniusweb.actions.PartyId;
+import geniusweb.bidspace.AllBidsList;
+import geniusweb.connection.ConnectionEnd;
+import geniusweb.issuevalue.Bid;
+import geniusweb.party.Capabilities;
+import geniusweb.party.inform.ActionDone;
+import geniusweb.party.inform.Finished;
+import geniusweb.party.inform.Inform;
+import geniusweb.party.inform.Settings;
+import geniusweb.party.inform.YourTurn;
+import geniusweb.profile.Profile;
+import geniusweb.profile.utilityspace.LinearAdditive;
+import geniusweb.progress.ProgressRounds;
+import geniusweb.references.Parameters;
+import geniusweb.references.ProfileRef;
+import geniusweb.references.ProtocolRef;
+import geniusweb.references.Reference;
+import tudelft.utilities.listener.DefaultListenable;
+import tudelft.utilities.logging.Reporter;
+
+public class SimpleBoaTest {
+
+	private static final String SAOP = "SAOP";
+	private static final PartyId otherparty = new PartyId("other");
+	private static final String PROFILE = "src/test/resources/testprofile.json";
+	private final static ObjectMapper jackson = new ObjectMapper();
+
+	private SimpleBoa party;
+	private final TestConnection connection = new TestConnection();
+	private final ProtocolRef protocol = mock(ProtocolRef.class);
+	private final ProgressRounds progress = mock(ProgressRounds.class);
+	private Settings settings;
+	private LinearAdditive profile;
+	private final Parameters parameters = new Parameters();
+
+	@Before
+	public void before() throws JsonParseException, JsonMappingException,
+			IOException, URISyntaxException {
+		party = new SimpleBoa();
+		settings = new Settings(new PartyId("party1"),
+				new ProfileRef(new URI("file:" + PROFILE)), protocol, progress,
+				parameters);
+
+		String serialized = new String(Files.readAllBytes(Paths.get(PROFILE)),
+				StandardCharsets.UTF_8);
+		profile = (LinearAdditive) jackson.readValue(serialized, Profile.class);
+
+	}
+
+	@Test
+	public void smokeTest() {
+	}
+
+	@Test
+	public void getDescriptionTest() {
+		assertNotNull(party.getDescription());
+	}
+
+	@Test
+	public void getCapabilitiesTest() {
+		Capabilities capabilities = party.getCapabilities();
+		assertFalse("party does not define protocols",
+				capabilities.getBehaviours().isEmpty());
+	}
+
+	@Test
+	public void testInformConnection() {
+		party.connect(connection);
+		// agent should not start acting just after an inform
+		assertEquals(0, connection.getActions().size());
+	}
+
+	@Test
+	public void testInformSettings() {
+		party.connect(connection);
+		connection.notifyListeners(settings);
+		assertEquals(0, connection.getActions().size());
+	}
+
+	@Test
+	public void testInformAndConnection() {
+		party.connect(connection);
+		party.notifyChange(settings);
+		assertEquals(0, connection.getActions().size());
+	}
+
+	@Test
+	public void testOtherWalksAway() {
+		party.connect(connection);
+		party.notifyChange(settings);
+
+		party.notifyChange(new ActionDone(new EndNegotiation(otherparty)));
+
+		// party should not act at this point
+		assertEquals(0, connection.getActions().size());
+	}
+
+	@Test
+	public void testAgentHasFirstTurn() {
+		party.connect(connection);
+		party.notifyChange(settings);
+
+		party.notifyChange(new YourTurn());
+		assertEquals(1, connection.getActions().size());
+		assertTrue(connection.getActions().get(0) instanceof Offer);
+	}
+
+	@Test
+	public void testAgentAccepts() {
+		// at very start, only perfect bid is accepted.
+		// so set time at 10% where good bids are also accepted.
+		when(progress.get(any())).thenReturn(0.1);
+
+		party.connect(connection);
+		party.notifyChange(settings);
+
+		Bid bid = findGoodBid();
+		party.notifyChange(new ActionDone(new Offer(otherparty, bid)));
+		party.notifyChange(new YourTurn());
+		assertEquals(1, connection.getActions().size());
+		assertTrue(connection.getActions().get(0) instanceof Accept);
+
+	}
+
+	@Test
+	public void testAgentLogsFinal() {
+		// this log output is optional, this is to show how to check log
+		Reporter reporter = mock(Reporter.class);
+		party = new SimpleBoa(reporter);
+		party.connect(connection);
+		party.notifyChange(settings);
+		party.notifyChange(new Finished(null));
+
+		verify(reporter).log(eq(Level.INFO),
+				eq("Final ourcome:Finished[null]"));
+	}
+
+	@Test
+	public void testGetCapabilities() {
+		assertTrue(party.getCapabilities().getBehaviours().contains(SAOP));
+	}
+
+	private Bid findGoodBid() {
+		for (Bid bid : new AllBidsList(profile.getDomain())) {
+			if (profile.getUtility(bid)
+					.compareTo(BigDecimal.valueOf(0.7)) > 0) {
+				return bid;
+			}
+		}
+		throw new IllegalStateException(
+				"Test can not be done: there is no good bid with utility>0.7");
+	}
+
+}
+
+/**
+ * A "real" connection object, because the party is going to subscribe etc, and
+ * without a real connection we would have to do a lot of mocks that would make
+ * the test very hard to read.
+ *
+ */
+class TestConnection extends DefaultListenable<Inform>
+		implements ConnectionEnd<Inform, Action> {
+	private List<Action> actions = new LinkedList<>();
+
+	@Override
+	public void send(Action action) throws IOException {
+		actions.add(action);
+	}
+
+	@Override
+	public Reference getReference() {
+		return null;
+	}
+
+	@Override
+	public URI getRemoteURI() {
+		return null;
+	}
+
+	@Override
+	public void close() {
+
+	}
+
+	@Override
+	public Error getError() {
+		return null;
+	}
+
+	public List<Action> getActions() {
+		return actions;
+	}
+
+}
Index: /exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java
===================================================================
--- /exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java	(revision 19)
+++ /exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java	(revision 20)
@@ -126,7 +126,7 @@
 
 		Action myAction;
-		if (bid == null || lastReceivedBid != null
+		if (bid == null || (lastReceivedBid != null
 				&& utilspace.getUtility(lastReceivedBid)
-						.compareTo(utilspace.getUtility(bid)) >= 0) {
+						.compareTo(utilspace.getUtility(bid)) >= 0)) {
 			// if bid==null we failed to suggest next bid.
 			myAction = new Accept(me, lastReceivedBid);
@@ -155,6 +155,8 @@
 		BigDecimal utilityGoal = utilityGoal(time, getE());
 		ImmutableList<Bid> options = extendedspace.getBids(utilityGoal);
-		if (options.size() == BigInteger.ZERO)
-			return null;
+		if (options.size() == BigInteger.ZERO) {
+			// if we can't find good bid, get max util bid....
+			options = extendedspace.getBids(extendedspace.getMax());
+		}
 		// pick a random one.
 		return options.get(new Random().nextInt(options.size().intValue()));
Index: /opponentmodel/src/main/java/geniusweb/opponentmodel/FrequencyOpponentModel.java
===================================================================
--- /opponentmodel/src/main/java/geniusweb/opponentmodel/FrequencyOpponentModel.java	(revision 19)
+++ /opponentmodel/src/main/java/geniusweb/opponentmodel/FrequencyOpponentModel.java	(revision 20)
@@ -24,21 +24,26 @@
  * (as you might expect as {@link NumberValueSetUtilities} is only affected by
  * the endpoints).
- *
+ * <p>
+ * immutable.
  */
 public class FrequencyOpponentModel implements UtilitySpace, OpponentModel {
 
 	private static final int DECIMALS = 4; // accuracy of our computations.
+	private static int serial = 1; // counter for auto name generation
+
 	private final Domain domain;
 	private final Map<String, Map<Value, Integer>> bidFrequencies;
 	private final BigDecimal totalBids;
-	private static int serial = 1; // counter for auto name generation
-
-	public FrequencyOpponentModel(Domain domain) {
-		/*
-		 * simply reset the whole model and make a new one... maybe this can be
-		 * done smarter for minor changes? map with empth hashmap for each
-		 * issue.
-		 */
-		this(domain,
+
+	public FrequencyOpponentModel() {
+		this.domain = null;
+		this.bidFrequencies = null;
+		this.totalBids = BigDecimal.ZERO;
+	}
+
+	@Override
+	public FrequencyOpponentModel with(Domain domain, Bid resBid) {
+		// FIXME merge already available frequencies?
+		return new FrequencyOpponentModel(domain,
 				domain.getIssues().stream().collect(
 						Collectors.toMap(iss -> iss, iss -> new HashMap<>())),
@@ -115,10 +120,4 @@
 	}
 
-	/**
-	 * {@inheritDoc}
-	 * 
-	 * <h1>change info</h1> This replaces update(Bid). Now you pass the entire
-	 * action and the progress instead of just the bid.
-	 */
 	@Override
 	public FrequencyOpponentModel with(Action action, Progress progress) {
@@ -127,17 +126,15 @@
 
 		Bid bid = ((Offer) action).getBid();
-		String err = domain.isComplete(bid);
-		if (err != null) {
-			throw new IllegalArgumentException(err);
-		}
 		Map<String, Map<Value, Integer>> newFreqs = cloneMap(bidFrequencies);
 		for (String issue : domain.getIssues()) {
 			Map<Value, Integer> freqs = newFreqs.get(issue);
 			Value value = bid.getValue(issue);
-			Integer oldfreq = freqs.get(value);
-			if (oldfreq == null) {
-				oldfreq = 0;
+			if (value != null) {
+				Integer oldfreq = freqs.get(value);
+				if (oldfreq == null) {
+					oldfreq = 0;
+				}
+				freqs.put(value, oldfreq + 1);
 			}
-			freqs.put(value, oldfreq + 1);
 		}
 
Index: /opponentmodel/src/main/java/geniusweb/opponentmodel/OpponentModel.java
===================================================================
--- /opponentmodel/src/main/java/geniusweb/opponentmodel/OpponentModel.java	(revision 19)
+++ /opponentmodel/src/main/java/geniusweb/opponentmodel/OpponentModel.java	(revision 20)
@@ -2,4 +2,5 @@
 
 import geniusweb.actions.Action;
+import geniusweb.issuevalue.Bid;
 import geniusweb.issuevalue.Domain;
 import geniusweb.profile.Profile;
@@ -13,6 +14,24 @@
  * Domain as argument. unfortunately this can not be enforced in a java
  * interface
+ * 
+ * <p>
+ * <em>MUST</em> have an empty constructor as these are also used as part of the
+ * BOA framework.
+ * 
  */
 public interface OpponentModel extends Profile {
+
+	/**
+	 * Initializes the model. This function must be called first after
+	 * constructing an instance. It can also be called later, if there is a
+	 * change in the domain or resBid.
+	 * 
+	 * @param domain the domain to work with
+	 * @param resBid the reservation bid, or null if no reservationbid is
+	 *               available.
+	 * @return OpponentModel that uses given domain and reservationbid.
+	 * 
+	 */
+	OpponentModel with(Domain domain, Bid resBid);
 
 	/**
Index: /opponentmodel/src/test/java/geniusweb/profile/opponentmodel/FrequencyOppModelTest.java
===================================================================
--- /opponentmodel/src/test/java/geniusweb/profile/opponentmodel/FrequencyOppModelTest.java	(revision 19)
+++ /opponentmodel/src/test/java/geniusweb/profile/opponentmodel/FrequencyOppModelTest.java	(revision 20)
@@ -87,8 +87,8 @@
 		bid3 = new Bid(issuevalues);
 
-		oppModel1 = new FrequencyOpponentModel(domain);
-		oppModel1b = new FrequencyOpponentModel(domain);
-		oppModel2 = new FrequencyOpponentModel(domain2);
-		oppModel3 = new FrequencyOpponentModel(domain3);
+		oppModel1 = new FrequencyOpponentModel().with(domain, null);
+		oppModel1b = new FrequencyOpponentModel().with(domain, null);
+		oppModel2 = new FrequencyOpponentModel().with(domain2, null);
+		oppModel3 = new FrequencyOpponentModel().with(domain3, null);
 		oppModel4 = oppModel3.with(new Offer(other, bid1), progress);
 
@@ -113,15 +113,16 @@
 	@Test(expected = NullPointerException.class)
 	public void smokeTestNull() {
-		new FrequencyOpponentModel(null);
+		new FrequencyOpponentModel().with((Domain) null, null);
 	}
 
 	@Test
 	public void smokeTest() {
-		new FrequencyOpponentModel(domain);
+		new FrequencyOpponentModel().with(domain, null);
 	}
 
 	@Test
 	public void testEmptyModel() {
-		FrequencyOpponentModel oppModel = new FrequencyOpponentModel(domain);
+		FrequencyOpponentModel oppModel = new FrequencyOpponentModel()
+				.with(domain, null);
 		assertEquals(BigDecimal.ONE, oppModel.getUtility(bid1));
 		assertEquals(BigDecimal.ONE, oppModel.getUtility(bid2));
@@ -153,3 +154,11 @@
 	}
 
+	@Test
+	public void testPartialBidUpdate() {
+		FrequencyOpponentModel oppModel = oppModel1.with(new Offer(other, bid1),
+				progress);
+		Bid partialbid = new Bid(ISS1, I1V1);
+		oppModel.with(new Offer(other, partialbid), progress);
+	}
+
 }
Index: /profile/src/test/java/geniusweb/profile/utilityspace/LinearAdditiveSerializationTest.java
===================================================================
--- /profile/src/test/java/geniusweb/profile/utilityspace/LinearAdditiveSerializationTest.java	(revision 19)
+++ /profile/src/test/java/geniusweb/profile/utilityspace/LinearAdditiveSerializationTest.java	(revision 20)
@@ -27,4 +27,5 @@
 
 public class LinearAdditiveSerializationTest {
+
 	private static final BigDecimal VAL2 = new BigDecimal("0.2");
 	private static final BigDecimal VAL3 = new BigDecimal("0.3");
@@ -106,5 +107,4 @@
 	@Test
 	public void testSerialize() throws JsonProcessingException {
-		ObjectMapper jackson = new ObjectMapper();
 		String string = jackson.writeValueAsString(space);
 		System.out.println(string);
@@ -114,5 +114,4 @@
 	@Test
 	public void testDeserialize() throws IOException {
-		ObjectMapper jackson = new ObjectMapper();
 		assertEquals(space, jackson.readValue(serialized, Profile.class));
 	}
@@ -120,5 +119,4 @@
 	@Test(expected = InvalidDefinitionException.class)
 	public void testDeserializeWrongIssues() throws IOException {
-		ObjectMapper jackson = new ObjectMapper();
 		jackson.readValue(serializedWrongIssues, Profile.class);
 	}
Index: /profileconnection/src/main/java/geniusweb/profileconnection/WebsocketProfileConnector.java
===================================================================
--- /profileconnection/src/main/java/geniusweb/profileconnection/WebsocketProfileConnector.java	(revision 19)
+++ /profileconnection/src/main/java/geniusweb/profileconnection/WebsocketProfileConnector.java	(revision 20)
@@ -49,4 +49,6 @@
 		this.uri = uri;
 		this.logger = reporter;
+		// see #1763 expected max size of profiles.
+		wscontainer.setDefaultMaxTextMessageBufferSize(200000);
 		wscontainer.connectToServer(this, uri);
 	}
Index: /protocol/src/main/java/geniusweb/protocol/session/SessionResult.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/SessionResult.java	(revision 20)
+++ /protocol/src/main/java/geniusweb/protocol/session/SessionResult.java	(revision 20)
@@ -0,0 +1,151 @@
+package geniusweb.protocol.session;
+
+import java.util.Collections;
+import java.util.List;
+
+import com.fasterxml.jackson.annotation.JsonAutoDetect;
+import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+import com.fasterxml.jackson.annotation.JsonTypeInfo;
+
+import geniusweb.issuevalue.Bid;
+import geniusweb.references.PartyWithProfile;
+
+/**
+ * All results collected from running a session. Normally this does not contain
+ * all the details, only the final outcome and other global notes.
+ */
+@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE)
+public class SessionResult {
+	private final List<PartyWithProfile> participants;
+	private final Bid agreement;
+	private final List<Double> penalties;
+
+	// add more type info so that jackson can deserialize the actual class
+	@JsonTypeInfo(use = JsonTypeInfo.Id.CLASS, include = JsonTypeInfo.As.WRAPPER_OBJECT)
+	private final Throwable error;
+
+	/**
+	 * 
+	 * @param participants the list oof {@link PartyWithProfile}, in the proper
+	 *                     order (this is relevant for the protocol etc). Should
+	 *                     never be null. Some of them may have entered later of
+	 *                     left early. This list should contain them all.
+	 * @param agreement    the final agreement {@link Bid} of the session. Null
+	 *                     if no agreement was reached.
+	 * @param penalties    the penalties in [0,1] for each participant, same
+	 *                     order as the participants list.
+	 * @param error        a fatal error that terminated the session. Non-fatal
+	 *                     errors (warnings) are not to be reported. Null if no
+	 *                     fatal error occured (session ended following the
+	 *                     protocol). Normally, a fatal error results in no
+	 *                     agreement but there might be protocols that allow a
+	 *                     session to end with an error but stick with a already
+	 *                     reached agreement as well.
+	 */
+	@JsonCreator
+	public SessionResult(
+			@JsonProperty("participants") List<PartyWithProfile> participants,
+			@JsonProperty("agreement") Bid agreement,
+			@JsonProperty("penalties") List<Double> penalties,
+			@JsonProperty("error") Throwable error) {
+		this.participants = participants;
+		this.agreement = agreement;
+		this.penalties = penalties;
+		this.error = error;
+	}
+
+	/**
+	 * 
+	 * @return the list oof {@link PartyWithProfile}, in the proper order (this
+	 *         is relevant for the protocol etc). Should never be null. Some of
+	 *         them may have entered later of left early. This list should
+	 *         contain them all.
+	 */
+	public List<PartyWithProfile> getParticipants() {
+		return Collections.unmodifiableList(participants);
+	}
+
+	/**
+	 * 8return the final agreement {@link Bid} of the session. Null if no
+	 * agreement was reached.
+	 */
+	public Bid getAgreement() {
+		return agreement;
+	};
+
+	/**
+	 * 
+	 * @return list of penalties, in same order as {@link #getParticipants()}.
+	 */
+	public List<Double> getPenalties() {
+		return Collections.unmodifiableList(penalties);
+	}
+
+	/**
+	 * 
+	 * @return a fatal error that terminated the session. Non-fatal errors
+	 *         (warnings) are not to be reported. Null if no fatal error occured
+	 *         (session ended following the protocol). Normally, a fatal error
+	 *         results in no agreement but there might be protocols that allow a
+	 *         session to end with an error but stick with a already reached
+	 *         agreement as well.
+	 */
+	public Throwable getError() {
+		return error;
+	}
+
+	@Override
+	public String toString() {
+		return "SessionResult[" + participants + "," + agreement + ","
+				+ penalties + "," + error + "]";
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result
+				+ ((agreement == null) ? 0 : agreement.hashCode());
+		result = prime * result + ((error == null) ? 0 : error.hashCode());
+		result = prime * result
+				+ ((participants == null) ? 0 : participants.hashCode());
+		result = prime * result
+				+ ((penalties == null) ? 0 : penalties.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		SessionResult other = (SessionResult) obj;
+		if (agreement == null) {
+			if (other.agreement != null)
+				return false;
+		} else if (!agreement.equals(other.agreement))
+			return false;
+		if (error == null) {
+			if (other.error != null)
+				return false;
+		} else if (!error.equals(other.error))
+			return false;
+		if (participants == null) {
+			if (other.participants != null)
+				return false;
+		} else if (!participants.equals(other.participants))
+			return false;
+		if (penalties == null) {
+			if (other.penalties != null)
+				return false;
+		} else if (!penalties.equals(other.penalties))
+			return false;
+		return true;
+	}
+
+}
Index: /protocol/src/main/java/geniusweb/protocol/session/SessionState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/SessionState.java	(revision 19)
+++ /protocol/src/main/java/geniusweb/protocol/session/SessionState.java	(revision 20)
@@ -65,3 +65,10 @@
 	 */
 	Bid getAgreement();
+
+	/**
+	 * 
+	 * @return the {@link SessionResult}. Assumes {@link #isFinal(long)}. result
+	 *         may be undefined if not.
+	 */
+	SessionResult getResult();
 }
Index: /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java	(revision 19)
+++ /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java	(revision 20)
@@ -19,4 +19,5 @@
 import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
 import geniusweb.protocol.session.DefaultSessionState;
+import geniusweb.protocol.session.SessionResult;
 import geniusweb.protocol.session.SessionSettings;
 import geniusweb.references.PartyWithProfile;
@@ -248,3 +249,12 @@
 	}
 
+	@Override
+	public SessionResult getResult() {
+		List<Double> emptylist = new LinkedList<>();
+		for (int n = 0; n < getConnections().size(); n++)
+			emptylist.add(0d);
+		return new SessionResult(getSettings().getAllParties(), getAgreement(),
+				emptylist, getError());
+	}
+
 }
Index: /protocol/src/main/java/geniusweb/protocol/session/shaop/BareSHAOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/shaop/BareSHAOPState.java	(revision 19)
+++ /protocol/src/main/java/geniusweb/protocol/session/shaop/BareSHAOPState.java	(revision 20)
@@ -1,4 +1,5 @@
 package geniusweb.protocol.session.shaop;
 
+import java.util.Arrays;
 import java.util.Collections;
 import java.util.LinkedList;
@@ -13,4 +14,5 @@
 import geniusweb.protocol.ProtocolException;
 import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
+import geniusweb.protocol.session.SessionResult;
 import geniusweb.protocol.session.SessionSettings;
 import geniusweb.protocol.session.SessionState;
@@ -169,4 +171,21 @@
 
 	@Override
+	public SessionResult getResult() {
+		Double[] penalties = new Double[partyNumbers.size()];
+		for (PartyId party : partyNumbers.keySet()) {
+			Double spent = totalSpent.get(party);
+			if (spent == null) {
+				spent = 0d;
+			} else {
+				spent = Math.max(0, Math.min(1.0, spent));
+			}
+			penalties[partyNumbers.get(party)] = spent;
+		}
+		return new SessionResult(getSettings().getAllParties(), getAgreement(),
+				Arrays.asList(penalties), getError());
+
+	}
+
+	@Override
 	public int hashCode() {
 		final int prime = 31;
Index: /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsProtocol.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsProtocol.java	(revision 19)
+++ /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsProtocol.java	(revision 20)
@@ -6,7 +6,7 @@
 import geniusweb.events.TournamentStarted;
 import geniusweb.protocol.CurrentNegoState;
-import geniusweb.protocol.SessionResult;
 import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
 import geniusweb.protocol.session.SessionProtocol;
+import geniusweb.protocol.session.SessionResult;
 import geniusweb.protocol.session.SessionSettings;
 import geniusweb.protocol.session.SessionState;
@@ -83,7 +83,5 @@
 				// List<TeamOfPartiesAndProfiles> participants =
 				// sessionstate.getSettings().getParticipants()
-				SessionResult result = new SessionResult(
-						sessionstate.getSettings().getAllParties(),
-						sessionstate.getAgreement(), sessionstate.getError());
+				SessionResult result = sessionstate.getResult();
 				state = state.with(result);
 				notifyListeners(new CurrentNegoState(state));
Index: /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsState.java	(revision 19)
+++ /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsState.java	(revision 20)
@@ -6,5 +6,5 @@
 
 import geniusweb.protocol.ProtocolException;
-import geniusweb.protocol.SessionResult;
+import geniusweb.protocol.session.SessionResult;
 import geniusweb.protocol.session.SessionSettings;
 import geniusweb.protocol.tournament.TournamentState;
Index: /protocol/src/test/java/geniusweb/protocol/session/DefaultSessionStateTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/DefaultSessionStateTest.java	(revision 19)
+++ /protocol/src/test/java/geniusweb/protocol/session/DefaultSessionStateTest.java	(revision 20)
@@ -139,3 +139,14 @@
 	}
 
+	@Override
+	public SessionResult getResult() {
+
+		List<Double> emptylist = new LinkedList<>();
+		for (int n = 0; n < getConnections().size(); n++)
+			emptylist.add(0d);
+		return new SessionResult(getSettings().getAllParties(), getAgreement(),
+				emptylist, getError());
+
+	}
+
 }
